=== debian/changelog ===
vecgeom (1.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.0+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 11 May 2022 21:43:24 +0200

vecgeom (1.1.20+dfsg-2) unstable; urgency=medium

  * Add vecgeom-dev package again for annoing CMake build files
  * Use TARGET_ARCHITECTURE=x86-64 for Vc on amd64
  * Fix reproducibility via CMAKE_BUILD_RPATH_USE_ORIGIN=ON

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 07 Apr 2022 21:32:44 +0200

vecgeom (1.1.20+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.20+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 01 Apr 2022 13:52:35 +0200

vecgeom (1.1.19+dfsg-1) unstable; urgency=medium

  * New upstream version 1.1.19+dfsg
  * Build with C++20 support for std::experimental::simd backend
  * Build with SSE2 on amd64
  * Build shared libraries

 -- Stephan Lachnit <stephanlachnit@debian.org>  Tue, 29 Mar 2022 15:27:00 +0200

vecgeom (1.1.18+dfsg-2) unstable; urgency=medium

  * Fix not compiling on anything except i386 and amd64

 -- Stephan Lachnit <stephanlachnit@debian.org>  Fri, 25 Feb 2022 15:47:56 +0100
