=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Use Vc only on amd64, arm, arm64 and i386, else Scalar
ifneq (,$(filter $(DEB_TARGET_ARCH),amd64 arm arm64 i386))
	VECGEOM_BACKEND=Vc
	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=none
else
	VECGEOM_BACKEND=Scalar
endif

# Use x86 VC and SSE2 only on amd64
ifneq (,$(filter $(DEB_TARGET_ARCH),amd64))
	VECGEOM_VECTOR=sse2
	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=x86-64
else
	VECGEOM_VECTOR=empty
endif

# Use Embree only on any-amd64
ifneq (,$(filter $(DEB_TARGET_ARCH),amd64))
	VECGEOM_EMBREE=ON
else
	VECGEOM_EMBREE=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_CXX_STANDARD=20 \
		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
		-DBUILD_SHARED_LIBS=ON \
		-DBUILD_TESTING=OFF \
		-DVECGEOM_GDML=ON \
		-DVECGEOM_EMBREE=$(VECGEOM_EMBREE) \
		-DVECGEOM_VECTOR=$(VECGEOM_VECTOR) \
		-DVECGEOM_BACKEND=$(VECGEOM_BACKEND) $(VC_TARGET_ARCHITECTURE)
