## vecgeom 1.2.1%2Bdfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 include(ExternalProject)
 
 project(VecGeom
-  VERSION 1.2.0
+  VERSION 1.2.1
   DESCRIPTION "Vectorized geometry library for particle-detector simulation"
   HOMEPAGE_URL "https://gitlab.cern.ch/VecGeom/VecGeom"
   LANGUAGES C CXX)
