## vecgeom 1.2.1+dfsg

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,17 @@
 ## TESTING
 ################################################################################
 # Helper Macros/Functions
+
+add_definitions(-UNDEBUG) # ensure asserts are enabled in all tests
 
 macro(build_executables EXECUTABLES)
   foreach(EXECUTABLE ${EXECUTABLES})
     get_filename_component(TARGET_NAME ${EXECUTABLE} NAME_WE)
     add_executable(${TARGET_NAME} ${EXECUTABLE})
-    target_link_libraries(${TARGET_NAME} PUBLIC $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>)
+    target_link_libraries(${TARGET_NAME} PUBLIC 
+      $<IF:$<BOOL:${VECGEOM_ENABLE_CUDA}>,vecgeomcuda_static,vecgeom>
+      $<$<BOOL:${VECGEOM_TEST_BENCHMARK}>:VecGeomBenchmark>
+      $<$<BOOL:${VECGEOM_ROOT}>:VecGeomUtilities>)
   endforeach()
 endmacro()
 
@@ -42,15 +47,36 @@
 # Download data if required
 message(STATUS "Checking data files required for tests")
 if(VECGEOM_ROOT)
-  download_if_not_installed("https://cernbox.cern.ch/index.php/s/pn2UkCtloi7i0xy/download"
+  download_if_not_installed("https://cern.ch/geant4-data/geometry/detectors/cms2015.root"
     "cms2015.root"
     "${CMAKE_CURRENT_BINARY_DIR}"
     "fb3ede867532b372c5e6f7138d00c07e")
-  download_if_not_installed("https://cernbox.cern.ch/index.php/s/dTChF8iKEUQHMxo/download"
+  download_if_not_installed("https://cern.ch/geant4-data/geometry/detectors/ExN03.root"
     "ExN03.root"
     "${CMAKE_CURRENT_BINARY_DIR}"
     "b6b0cfdd5035117171bfe1b7f1f40c3f")
 endif()
+
+################################################################################
+# Define Testing libraries
+################################################################################
+if(VECGEOM_TEST_BENCHMARK)
+  add_subdirectory(VecGeomBenchmark)
+endif()
+
+if(VECGEOM_ROOT)
+  add_library(VecGeomUtilities STATIC 
+    utilities/ShapeDebugger.cpp 
+    utilities/ShapeDebugger.h
+    utilities/Visualizer.cpp
+    utilities/Visualizer.h)
+  target_include_directories(VecGeomUtilities PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
+  target_link_libraries(VecGeomUtilities 
+    PUBLIC vecgeom ROOT::Graf3d 
+    PRIVATE ROOT::Core ROOT::Geom ROOT::Gpad)
+endif()
+
+
 ################################################################################
 # Define executables
 ################################################################################
@@ -134,8 +160,8 @@
     globalbenchmarks/TraceTrack.cpp
     globalbenchmarks/XRayBenchmarkFromROOTFile.cpp
     # ???
-    ${PROJECT_SOURCE_DIR}/services/NavigationSpecializerTest.cpp
-    ${PROJECT_SOURCE_DIR}/services/LibraryGenerator.cpp)
+    services/NavigationSpecializerTest.cpp
+    services/LibraryGenerator.cpp)
 
   if(VECGEOM_TEST_BENCHMARK)
     list(APPEND TEST_EXECUTABLES_ROOT
@@ -220,7 +246,9 @@
   unit_tests/TestTorus2.cpp
   unit_tests/TestParaboloid.cpp
   unit_tests/TestReducedPolycone.cpp
-  unit_tests/TestUtils3D.cpp)
+  unit_tests/TestUtils3D.cpp
+  unit_tests/TestMarchingCubes.cpp
+  unit_tests/TestVECGEOM-601.cpp)
 
 if(NOT VECGEOM_ENABLE_CUDA)
   list(APPEND TEST_EXECUTABLES_SHAPES
@@ -244,6 +272,7 @@
 add_test(NAME TestTrap COMMAND TestTrap)
 add_test(NAME TestTrd COMMAND TestTrd)
 add_test(NAME TestTube COMMAND TestTube)
+add_test(NAME TestVECGEOM-601 COMMAND TestVECGEOM-601)
 if(NOT VECGEOM_ENABLE_CUDA)
   add_test(NAME TestTessellated COMMAND TestTessellated)
 endif()
@@ -272,6 +301,13 @@
 
 ################################################################################
 # - Shape Tester tests
+add_library(VecGeomShapeTester STATIC 
+  shape_tester/ShapeTester.h 
+  shape_tester/ShapeTester.cpp #includes ConventionChecker.cpp ...
+  )
+target_include_directories(VecGeomShapeTester PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/shaper_tester")
+target_link_libraries(VecGeomShapeTester PUBLIC vecgeom $<$<BOOL:${VECGEOM_ROOT}>:VecGeomUtilities>)
+
 set(TEST_EXECUTABLES_SHAPETESTER
   shape_tester/shape_testBox.cpp
   shape_tester/shape_testSExtru.cpp
@@ -305,26 +341,3 @@
 endif()
 
 if(NOT VECGEOM_ENABLE_CUDA)
-  list(APPEND TEST_EXECUTABLES_SHAPETESTER shape_tester/shape_testTessellated.cpp)
-endif()
-
-if(VECGEOM_TEST_BENCHMARK)
-  build_executables("${TEST_EXECUTABLES_SHAPETESTER}")
-endif()
-
-
-if(VECGEOM_TEST_VALIDATION AND VECGEOM_ROOT)
-  macro(add_cmsshapevalidation_test TESTNAME SHAPEFILE)
-    add_test(NAME ${TESTNAME} COMMAND bash -c "${PROJECT_SOURCE_DIR}/test/scripts/RunRandomValidation ${PROJECT_BINARY_DIR}/BenchmarkShapeFromROOTFile  ${CMAKE_CURRENT_BINARY_DIR}/cms2015.root  ${PROJECT_SOURCE_DIR}/test/cmstestdata/${SHAPEFILE}" )
-  endmacro()
-
-  # Adding various shapes tests for nightlies
-  add_cmsshapevalidation_test( tubevalidation cmstubes.txt )
-  add_cmsshapevalidation_test( trapvalidation cmstraps.txt )
-  add_cmsshapevalidation_test( polyconevalidation cmspolycones.txt )
-  add_cmsshapevalidation_test( polyhedravalidation cmspolyhedra.txt )
-  add_cmsshapevalidation_test( conevalidation cmscones.txt )
-  add_cmsshapevalidation_test( boxvalidation cmsboxes.txt )
-  #taken out due to problems: add_cmsshapevalidation_test( booleanvalidation cmsbooleans.txt )
-  #taken out due to Issue-133: add_cmsshapevalidation_test( torusvalidation cmstori.txt )
-endif()
