=== debian/changelog ===
vecgeom (1.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.1+dfsg

 -- Stephan Lachnit <stephanlachnit@debian.org>  Thu, 08 Dec 2022 14:03:05 +0100

vecgeom (1.2.0+dfsg-3) unstable; urgency=medium

  * Fix SSE4.2 dependence on non-amd64 systems

 -- Stephan Lachnit <stephanlachnit@debian.org>  Wed, 09 Nov 2022 23:16:06 +0100

vecgeom (1.2.0+dfsg-2) unstable; urgency=medium

  * Revert back to C++17
  * Add libtbb-dev to b-d to fix temporary FTBFS (original bug is in src:embree)
  * Build with SSE4.2 on amd64

 -- Stephan Lachnit <stephanlachnit@debian.org>  Sat, 10 Sep 2022 13:43:42 +0200
