=== debian/control ===
--- 
+++ 
@@ -59,6 +59,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ sse4.2-support [any-amd64],
 Description: geometry library for particle-detector simulation
  VecGeom is a vectorized geometry modeller library with hit-detection features
  as needed by particle detector simulation at the LHC and beyond.
@@ -87,6 +88,7 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
+ sse4.2-support [any-amd64],
 Description: GDML interoperability library for VecGeom
  VecGeom is a vectorized geometry modeller library with hit-detection features
  as needed by particle detector simulation at the LHC and beyond.
