=== debian/rules ===
--- 
+++ 
@@ -10,10 +10,10 @@
 	VECGEOM_BACKEND=Scalar
 endif
 
-# Use x86 VC and SSE2 only on amd64
+# Use x86 VC and SSE4.2 only on amd64
 ifneq (,$(filter $(DEB_TARGET_ARCH),amd64))
-	VECGEOM_VECTOR=sse2
-	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=x86-64
+	VECGEOM_VECTOR=sse4.2
+	VC_TARGET_ARCHITECTURE=-DTARGET_ARCHITECTURE=x86-64-v2
 else
 	VECGEOM_VECTOR=empty
 endif
@@ -30,7 +30,6 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DCMAKE_CXX_STANDARD=20 \
 		-DCMAKE_BUILD_RPATH_USE_ORIGIN=ON \
 		-DBUILD_SHARED_LIBS=ON \
 		-DBUILD_TESTING=OFF \
